#*-* coding: utf-8 *-*
import os
import time
from socket import *
from Communicator import *
from ModemMessage import *
from Util import *


class AbsCommunicator(Communicator):
    def __init__(self,name):
        self.flag = True
        self.Soc = None
        self.Connected = False
        self.Sat = ModemMessage("SatInfo")
        Communicator.__init__(self,name)
        p = Thread(target=self.Worker)
        p.start()
        self.TxArr = []
        p = Thread(target=self.TxWorker)
        p.start()
    def Init(self,ip,port):
        self.IP = str(ip)
        self.Port = int(port)
        Communicator.ResetFlag(self)
    def Start(self):
        from Project import pj 
        while 1:
            self.Soc = socket(AF_INET, SOCK_STREAM)
            self.out('Create New Socket')
            # self.Soc.connect((self.IP,self.Port))
            try:
				self.Soc.connect((self.IP,self.Port))
				self.out('Connected')
				self.Connected = True
				while 1 :
					self.Soc.settimeout(30.0)
					line = self.Soc.recv(1024)
					if len(line) == 0 : break
					# self.ProcData(line)
					if line[0:3] == '$KE' : self.ProcResponse(line)
					if line[0:2] != '$K' : pj.AbsSer.Bypass(line)
					if line[0:3] == '$KW' : self.SendToAntenna(line)
					if line[0:3] == '$KW' : self.ProcData(line)
            except: self.out('AbsCommunicator Retry.... (wait 5sec)')
            self.ResetFlag()
            
            # self.out('Connected {}:{}'.format(self.IP,self.Port))
            # self.Connected = True
            # while 1 :
				# self.Soc.settimeout(5.0)
				# line = self.Soc.recv(1024)
				# if len(line) == 0 : break
				# if line[0:3] == '$KE' : self.ProcResponse(line)
				# if line[0:2] != '$K' : pj.AbsSer.Bypass(line)
				# if line[0:3] == '$KW' : self.out(line)
            # self.ResetFlag()
            
            self.Connected = False
            self.Soc = None
            time.sleep(5)
    def ProcResponse(self,line): 
		from Project import pj 
		# print line
		lines = line.split(',')
		if lines[1] == 'SYS' :
			pj.Vcs.Lock = int(lines[2]);
			# self.Sat.RcvCnt = int(lines[3]);
    def ProcData(self,line): 
        lines = line.split(',')
        if len(lines) < 10 : return
        if lines[1] != "DAT_O" : return
        for dat in lines : 
            if dat[0:2] == "SN" : self.Sat.ID = dat[3:len(dat)]
            elif dat[0:2] == "NM" : self.Sat.Name = dat[3:len(dat)]
            elif dat[0:2] == "LT" : self.Sat.Position = dat[3:len(dat)]
            elif dat[0:2] == "SS" : self.Sat.SchMethod = dat[3:len(dat)]
            elif dat[0:2] == "TL" : self.Sat.SchThreshold = dat[3:len(dat)]
            elif dat[0:2] == "TS" : self.Sat.TrkMethod = dat[3:len(dat)]
            elif dat[0:2] == "RP" : self.Sat.RxPol = dat[3:len(dat)]
            elif dat[0:2] == "TR" : self.Sat.TRxPol = dat[3:len(dat)]
            elif dat[0:2] == "SO" : self.Sat.SkewTrimAng = dat[3:len(dat)]
            elif dat[0:2] == "BL" : self.Sat.LowLo = dat[3:len(dat)]
            elif dat[0:2] == "BH" : self.Sat.HighLo = dat[3:len(dat)]
            elif dat[0:2] == "TF" : self.Sat.TpFreq = dat[3:len(dat)]
            elif dat[0:2] == "VT" : self.Sat.LnbBandSel = dat[3:len(dat)]
            elif dat[0:2] == "SR" : self.Sat.TpSymb = dat[3:len(dat)]
            elif dat[0:2] == "RF" : self.Sat.RollOff = dat[3:len(dat)]
            elif dat[0:2] == "TP" : self.Sat.TxPol = dat[3:len(dat)]
            elif dat[0:2] == "CL" : self.Sat.BucLo = dat[3:len(dat)]
        self.Sat.RcvCnt += 1
        self.Sat.UTC = Util.UTC()
            
    def Bypass(self,dat): 
        # if self.Connected and len(dat) > 0: self.Soc.sendall(dat) 
        tmp = str(dat)
        # tmp = tmp + '\r\n'
        self.TxArr.append(tmp)
    def Send(self,dat):
        # if self.Connected : self.Soc.sendall(dat) 
        # self.out(dat)
        
        tmp = str(dat)
        # tmp = tmp + '\r\n'
        self.TxArr.append(tmp)
    def Worker(self):
		from Project import pj 
		time.sleep(2)
		cnt = 0
		cnt_i = 0
		while True:
			time.sleep(0.1)
			cnt += 1
			cnt_i += 1
			if cnt == 5 : 
				cnt = 0
				tmp = '$KB,SYS,Aa{},Ab{},Ac{},Ad{},Ae{},Ba{},Bb{},Bc{},Bd{},Be{},Bf{},T*\r\n'.format(
                        (pj.GpsMgr.Valid if pj.Sys.GpsManipulationUse == 0 else 1)
                        ,Util.UTC() #pj.GpsMgr.UTC
                        ,(pj.GpsMgr.Lat if pj.Sys.GpsManipulationUse == 0 else pj.Sys.GpsManipulationLat) 
                        ,(pj.GpsMgr.Lon if pj.Sys.GpsManipulationUse == 0 else pj.Sys.GpsManipulationLon) 
                        ,pj.GyroMgr.Heading
                        ,pj.Sys.Dat['Absp']['ClassType']
                        ,pj.Sys.Dat['Absp']['LnbBand1Lo']
                        ,pj.Sys.Dat['Absp']['LnbBand2Lo']
                        ,pj.Sys.Dat['Absp']['LnbBand3Lo']
                        ,pj.Sys.Dat['Absp']['LnbBand4Lo']
                        ,pj.Sys.Dat['Absp']['RollOff']
                    )
				# tmp = '$KB,SYS,Aa%d,Ab%.2f,Ac%.2f,Ad%.2f,Ba0,Bb10250,Bc10750,Bd11250,,Be9750,Bf0.25\r\n'%(
                        # pj.GpsMgr.Valid
                        # ,pj.GpsMgr.UTC
                        # ,pj.GpsMgr.Lat
                        # ,pj.GpsMgr.Lon
                    # )
				self.Send(tmp)
			if cnt_i == 50 : 
				cnt_i = 0
				tmp = '$KB,SYS,CaVCS01123,Cb0.123,T*\r\n'
				self.Send(tmp)

			self.SendToCompassData()
			# cps_dat = "<KB,DAT_S,STS,Aa{},Ab{},Ba{},Bb{},,\r\n".format(
                # (1 if pj.GyroMgr.Valid > 0 else 0)
                # ,pj.GyroMgr.Heading
                # ,pj.Vcs.Lock
                # ,pj.McuComm.Mcu.ModemCn
                # )
			# # self.out(cps_dat)
			# self.SendToAntenna(cps_dat)
            
			# Send to burst data of actived antenna.
			if pj.AntIfSel == 1 : 
				tmp = pj.AntCommA.Ant.Pop()
				if tmp != None : self.Send(tmp)
			elif pj.AntIfSel == 2 : 
				tmp = pj.AntSubComm.Ant.Pop()
				if tmp != None : self.Send(tmp)
			elif pj.AntIfSel == 3 : 
				tmp = pj.AntCommB.Ant.Pop()
				if tmp != None : self.Send(tmp)
			elif pj.AntIfSel == 4 : 
				tmp = pj.McuComm.Ant.Pop()
				if tmp != None : self.Send(tmp)
    def TxWorker(self):
        from Project import pj 
        time.sleep(5)
        while True:
            time.sleep(0.04)
            if len(self.TxArr) > 0 : 
                dat = self.TxArr.pop(0)
                if self.Connected : self.Soc.send(dat.encode())
    def SendToAntenna(self,line): 
		self.SendToAntennaA(line)
		self.SendToAntennaB(line)
    def SendToAntennaA(self,line): 
		from Project import pj 
		if pj.AntAInterface == 1 : 
			tmp = pj.AntCommA.Send(line)
		elif pj.AntAInterface == 2 : 
			tmp = pj.AntSubComm.Send(line)
    def SendToAntennaB(self,line): 
		from Project import pj 
		if pj.AntBInterface == 1 : 
			tmp = pj.AntCommB.Send(line)
		elif pj.AntBInterface == 2 : 
			tmp = pj.McuComm.Send(line)  
    def SendToCompassData(self): 
		from Project import pj 
		valid = (1 if pj.GyroMgr.Valid > 0 else 0)
        # transfer from offset of AntA to AntB, also offset of AntB..
		lock = pj.Vcs.Lock if pj.Sys.GetAbsExtLockSrcType() == 1 else pj.Vcs.LockFromConsole
		msgA = self.GetCompassData(valid,pj.GyroMgr.Heading,lock,pj.McuComm.Mcu.ModemCn,pj.Sys.GetSyncMode(),pj.AntB)
		msgB = self.GetCompassData(valid,pj.GyroMgr.Heading,lock,pj.McuComm.Mcu.ModemCn,pj.Sys.GetSyncMode(),pj.AntA)
		self.SendToAntennaA(msgA)
		self.SendToAntennaB(msgB)
		# print "msgA : "+ msgA;
		# print "msgB : "+ msgB;
    def GetCompassData(self,valid,heading,lock,cn,sync,ant):
        temp = ""
        if ant != None: 
            if ant.GetSyncStatus() > 0 :
                temp = "<KB,DAT_S,STS,Aa{},Ab{},Ba{},Bb{},Ca{},Cb{},Cc{},Cd{},Ce{},\r\n".format(
                     valid,
                     heading,
                     lock,
                     cn,
                     sync,
                     ant.GetSyncStatus(),
                     ant.GetSyncOffset0(),
                     ant.GetSyncOffset1(),
                     ant.GetSyncOffset2()
                    )
                # print temp
                return temp
            
        temp = "<KB,DAT_S,STS,Aa{},Ab{},Ba{},Bb{},\r\n".format(
            valid,
            heading,
            lock,
            cn
            )
        return temp

	

