#-*- coding:utf-8 -*-
import serial
from System import *
from Antenna import *
from NMEA import *
from Communicator import *

class AntennaSubCommunicator(Communicator):
    def __init__(self,name):
        Communicator.__init__(self,name)
        self.Ant = Antenna('Antenna')
        self.Nmea = NmeaFormatter()
        self.DevName = ''
        Communicator.ResetFlag(self)
        self.TxArr = []
        p = Thread(target=self.TxWorker)
        p.start()
    def Open(self,name,baudrate):
        self.out("Opend %s-%s"%(name,baudrate))
        self.DevName = name
        self.comm = serial.Serial(name, baudrate)
    def SetBaudrate(self,name,baudrate):
        self.Open(self.DevName, baudrate)
    def Close(self):
        self.comm.close()
    def Start(self):
        line = ""
        while True:
            ch  = self.comm.read(1)
            line += ch    
            if ch == '\n':
				self.DatProc(line)
				line = ""	
    def DatProc(self,line):
        self.out(line)
        if len(line) < 5 : return 
        if line[0:2] == '$K' : 
            lines = line.split(',')
            if len(lines) > 3 : 
				self.out(line)
				if lines[2] == 'STS' : self.Ant.DatProc(line)
				elif lines[2] == 'GPS' : self.Ant.Nmea.BurstGpsProc(line)
            self.SetFlag() 
        elif line[0:2] == '$G' : 
            self.out(line)
            self.Nmea.DatProc(line)
    def Send(self,dat):
        self.TxArr.append(dat)
    def TxWorker(self):
        while True:
            time.sleep(0.1)
            if len(self.TxArr) > 0 : 
                dat = self.TxArr.pop(0)
                self.Comm.write(dat.encode())



